//Script by ViezeOudeMan
//more info about available functions at http://www.zeroy.com/Script/
//Great tutorials on https://think-clan.com/ RIP - http://www.codjumper.com - http://modsonline.com/Tutorials-list-4.html helped alot :)

//important notes:
//when linking triggers use wait(0.05) to avoid errors
//when rotating with a linked trigger, the trigger brush must be created together with an origin brush - when the origin brush of the trigger has exacly the same size and spot as the trigger brush, the doors seem to work the best this way
//if a scriptmodel_brush consists only of an origin COD will crash when loading the map without error message - THIS SUCKS
//playing sounds that are "looping" in the .csv file doesnt seem to work except when played with ambientplay -> made my own looping function

main(){	
	maps\mp\_load::main();

	//sounds
	waterfallCanyon = getent("waterfallCanyon","targetname");
	waterCanyon = getent("waterCanyon","targetname");
	waterfallCanyon2 = getent("waterfallCanyon2","targetname");
	waterCanyon2 = getent("waterCanyon2","targetname");
	thread loopSound("Waterfall", 21, waterfallCanyon, "waterfallCanyon", 1, false);
	thread loopSound("WaterRunning", 14, waterCanyon, "waterCanyon", 1, false);
	thread loopSound("WaterRunning", 14, waterfallCanyon2, "waterfallCanyon2", 1, false);
	thread loopSound("WaterRunning", 14, waterCanyon2, "waterCanyon2", 1, false);

	//level settings
	game["allies"] = "american";
	game["axis"] = "german";
	game["american_soldiertype"] = "airborne";
	game["american_soldiervariation"] = "normal";
	game["german_soldiertype"] = "kriegsmarine";
	game["german_soldiervariation"] = "normal";
	//objectives
	//Objective_Add( 1, "invisible", getent("bhopGamePointMarker1","targetname").origin);
	
	//fx
	level._effect["fire"] = loadfx ("fx/fire/tinybon.efx");
	maps\mp\_fx::loopfx("fire", (1092, -2162, 10), 0.6);
	//first room
	maps\mp\_fx::loopfx("fire", (359, -8388, 518), 0.3);
	maps\mp\_fx::loopfx("fire", (360, -10300, 182), 0.3);
	maps\mp\_fx::loopfx("fire", (359, -8388, 518), 0.3);
	maps\mp\_fx::loopfx("fire", (-252, -9287, 230), 0.3);
	maps\mp\_fx::loopfx("fire", (972, -9288, 230), 0.3);
	maps\mp\_fx::loopfx("fire", (772, -8652, 64), 1);
	maps\mp\_fx::loopfx("fire", (-60, -8652, 64), 1);
	//hallway
	maps\mp\_fx::loopfx("fire", (-1256, -10524, 114), 0.8);//stand
	maps\mp\_fx::loopfx("fire", (-2516, -10514, 138), 0.8);
	maps\mp\_fx::loopfx("fire", (356, -10652, 114), 0.8);
	//traproom
	maps\mp\_fx::loopfx("fire", (-2528, -10704, 178), 0.8);
	maps\mp\_fx::loopfx("fire", (-2528, -11704, 178), 0.8);
	//naderoom
	maps\mp\_fx::loopfx("fire", (812, -10884, 114), 0.8);
	maps\mp\_fx::loopfx("fire", (1551, -10816, 466), 0.8);
	//unreachable room
	maps\mp\_fx::loopfx("fire", (-1369, -9412, 206), 0.3);
	//stairroom
	maps\mp\_fx::loopfx("fire", (-2529, -11832, 310), 0.3);
	maps\mp\_fx::loopfx("fire", (-2529, -12651, 290), 0.3);
	maps\mp\_fx::loopfx("fire", (-2529, -13248, 680), 0.3);
	maps\mp\_fx::loopfx("fire", (-2529, -11832, 1080), 0.3);
	//ballroom
	maps\mp\_fx::loopfx("fire", (-1425, -13644, 1314), 0.3);
	maps\mp\_fx::loopfx("fire", (4079, -13644, 546), 0.3);
	
	//variables
	level.radioChannels = 5;
	level.currentRadioChannel = 0;
	level.loopRadio = false;
	level.isKeyTaken = false;
	level.inputCode = "";
	level.inputCodeLength = 0;
	level.lockCode = "1638";
	level.isBigDoorUnlocked = false;
	level.elevatorStatus = 1; // 0 is down, 1 is up, 2 is moving
	level.shootingTargetSpeed = 2;

	level.aztecDoorRotate1Position = 6;
	level.aztecDoorRotate2Position = 7;
	level.aztecDoorRotate3Position = 4;
	level.isAztecDoorOpened = false;

	//precache
	precacheShader("white");
	precacheShader("black");
	precacheShader("textures/viezeoudeman/V_ForgottenTomb/gnomeChildjpg");
	precachestring(&"mapname_OBJ1");
	
	//threads
	thread mapInfo();
	thread moveDoor("frontDoor", "frontDoorTrigger", false, 120, 1, 0.1, 0.1);
	thread moveDoor("backDoor", "backDoorTrigger", false, 120, 1, 0.1, 0.1);
	thread moveBasementDoor();
	thread findKey();
	thread teleport(getent("homeTeleportTrigger","targetname"), (1600 ,-1200, 128));
	//thread breakableWallInvestigate();
	thread breakWall();
	thread moveElevator("elevatorUpTrigger");
	thread moveElevator("elevatorDownTrigger");
	thread shootingTarget("1", 1000, 4, 0, 0, 2);
	thread shootingTarget("2", 1000, 3, 1.5, 1.5, 2);
	thread shootingTarget("3", 300, 1.5, 0.2, 0.2, 0.5);
	thread shootingTarget("4", -500, 2, 0.8, 0.8, 1.5);
	thread shootingTarget("5", 0, 100, 0, 0, 2);
	thread shootingTargetSpeed();
	thread shootingProjectile();
	thread grenadeBox("grenadeBoxTrigger1");
	thread grenadeBox("grenadeBoxTrigger2");
	thread grenadeBox("grenadeBoxTrigger3");
	thread playRadio();
	thread playClubMusic();
	thread getDrunk();
	thread pictures();

	thread watefallMove();
	thread rotateBrush("aztecDoorRotate1Trigger", "aztecDoorRotate1", "yaw", true, true, 45, 0.5, 0, 0, "aztecDoor");
	thread rotateBrush("aztecDoorRotate2Trigger", "aztecDoorRotate2", "yaw", true, true, 45, 0.5, 0, 0, "aztecDoor");
	thread rotateBrush("aztecDoorRotate3Trigger", "aztecDoorRotate3", "yaw", true, true, 45, 0.5, 0, 0, "aztecDoor");
	
	for(i =  1; i < 23; i++){
		if(i >= 15){waitTime = 0.5;}
		else{waittime = 1.5;}
		thread fallingPlatforms("fallingPlatform" + i, "fallingPlatform" + i + "Trigger", waitTime);
	}
	thread floorTrap();
	thread giantBall();
}

teleport(trigger, location){
	while(1){
		trigger waittill("trigger", user);
		user setorigin(location); 			//user.angles		user.origin		user.newVariable = "example" 	user.health
		user setPlayerAngles((0,0,0));
	}	
}

giantBall(){
	gateTrigger = getent("giantBallGateTrigger", "targetname");
	giantBallGate = getent("giantBallGate", "targetname");
	trigger = getent("giantBallTrigger", "targetname");
	giantBall = getent("giantBall", "targetname");
	wait(0.05);
	trigger enableLinkTo();
	trigger linkTo(giantBall);
	origin = giantBall.origin;
	while(1){
		
		gateTrigger waittill("trigger");
		giantBall playsound("BigDoorSlide"); //new
		giantBallGate movez(216, 1, 1 ,0);
		
		giantBall movez(-512, 1, 1 ,0);
		giantBall waittill("movedone");
		giantBall rotatePitch(90, 3, 0, 2);
		thread moveBrush("", "giantBall", "x", false, false, 256, 3, 0, 1, "");
		giantBall waittill("rotatedone");
		
		thread rotateBrush("", "giantBall", "pitch", false, false, 1500, 25, 5, 0, "");
		giantBall moveTo((2512, -13848, 496), 25, 5, 0);
		giantBall waittill("movedone");
		
		giantBall rotatePitch(720, 10, 0, 0);
		thread moveBrush("", "giantBall", "x", false, false, 1830, 10, 0, 0, "");
		giantBall waittill("rotatedone");
		
		giantBall rotatePitch(120, 1, 0, 0);
		giantBall moveTo((4666, -13848, 0), 1, 0, 0);
		giantBall waittill("rotatedone");
		
		giantBall rotatePitch(-180, 2, 0, 0);
		thread moveBrush("", "giantBall", "z", false, false, -3000, 2, 0, 0, "");
		giantBall waittill("rotatedone");
		
		wait(1);
		giantBall.origin = origin;
		wait(1);
		giantBallGate movez(-248, 1, 1 ,0);
	}
}



floorTrap(){
	trigger = getent("floorTrapTrigger", "targetname");
	outerWall = getent("floorTrapOuterWall", "targetname");
	ceiling = getent("floorTrapCeiling", "targetname");
	ceilingKill = getent("floorTrapKillTrigger", "targetname");
	wait(0.05);
	ceilingKill enableLinkTo();
	ceilingKill linkTo(ceiling);
	
	while(1){
		trigger waittill("trigger");
		
		outerWall movez(256, 1.7, 0, 0);
		outerWall playsound("NormalDoorSlide");
		outerWall waittill("movedone");		
		
		wait(2);
		
		ceiling movez(-256, 7, 0, 0);
		ceiling playsound("BigDoorSlide");
		ceiling waittill("movedone");
		ceiling movez(256, 3, 0, 0);
		ceiling playsound("BigDoorSlide");
		ceiling waittill("movedone");
		ceiling playsound("SilentForgottentomb");
		outerWall movez(-256, 1.7, 0, 0);
		outerWall playsound("NormalDoorSlide");
		outerWall waittill("movedone");

	}
}


fallingPlatforms(platformName, triggerName, time){
	trigger = getent(triggerName, "targetname");
	platform = getent(platformName, "targetname");
	wait(0.05);
	trigger enableLinkTo();
	trigger linkTo(platform);
	origin = platform.origin;
	
	while(1){
		trigger waittill("trigger");
		platform playSound("Rumble");
		wait(time);
		platform playSound("FallingRocks");
		wait(0.20);
		platform.origin  = origin + (0, 0, -10);
		platform movez(-4000, 3, 0.5, 0);
		platform waittill("movedone");
		wait(1);
		platform.origin  = origin;
	}
}


/*
*
*/
rotateBrush(triggerName, entityName, rotateDirection, isLooping, needsTrigger, degrees, time, acc, dec, extraFunction){
	if(needsTrigger){trigger = getent(triggerName, "targetname");}
	brush = getent(entityName, "targetname");
	do{
		if(needsTrigger){trigger waittill("trigger", user);}		
		
		switch(extraFunction){
			case "aztecDoor":
				brush playsound("normalDoorSlide");
				 break;
				 
			default:
				break;
		}
		
		switch(rotateDirection){
			case "yaw":
				brush rotateYaw(degrees, time, acc, dec);
				break;
			case "pitch":
				brush rotatePitch(degrees, time, acc, dec);
				break;
			case "roll":
				brush rotateRoll(degrees, time, acc, dec);
				break;
			default:
				break;
		}
		brush waittill("rotatedone");
		
		switch(extraFunction){
			case "aztecDoor":
				brush playsound("SilentForgottentomb");
				switch(entityName){
					case "aztecDoorRotate1":
						if(level.aztecDoorRotate1Position == 7){level.aztecDoorRotate1Position = 0;}
						else{level.aztecDoorRotate1Position++;}
						break;
					case "aztecDoorRotate2":
						if(level.aztecDoorRotate2Position == 7){level.aztecDoorRotate2Position = 0;}
						else{level.aztecDoorRotate2Position++;}
						break;
					case "aztecDoorRotate3":
						if(level.aztecDoorRotate3Position == 7){level.aztecDoorRotate3Position = 0;}
						else{level.aztecDoorRotate3Position++;}
						break;
				}
				
				if(level.aztecDoorRotate1Position == 0 && level.aztecDoorRotate2Position == 0 && level.aztecDoorRotate3Position == 0 && level.isAztecDoorOpened == false){
					level.isAztecDoorOpened = true;
					thread moveBrush("", "aztecDoorLeft", "x", false, false, 80, 6, 5, 0, "");
					thread moveBrush("", "aztecDoorRight", "x", false, false, -80, 6, 5, 0, "");
					left = getent("aztecDoorLeft", "targetname");
					right = getent("aztecDoorRight", "targetname");
					left playsound("BigDoorSlide");
				}
				 break;
				 
			default:
				break;
		}	
	}while(isLooping);
}

moveBrush(triggerName, entityName, moveDirection, isLooping, needsTrigger, distance, time, acc, dec, extraFunction){
	if(needsTrigger){trigger = getent(triggerName, "targetname");}
	brush = getent(entityName, "targetname");
	
	do{	
		if(needsTrigger){trigger waittill("trigger", user);}
		
		switch(moveDirection){
			case "x":
				brush movex(distance, time, acc, dec);
				break;
			case "y":
				brush movey(distance, time, acc, dec);
				break;
			case "z":
				brush movez(distance, time, acc, dec);
				break;
			default:
				break;
		}
		brush waittill("movedone");
	}while(isLooping);
}

/*
*
*/
watefallMove(){
	trigger = getent("waterfallCanyon2move", "targetname");
	while(1){
		trigger waittill("trigger", user);
		originBrush = spawn("script_origin", user.origin);
		wait 0.05;
		//originBrush.origin = user.origin;
		//originBrush.angles = user.angles;
		user linkto(originBrush);	
		originBrush movey(190, 1, 0.9, 0);
		originBrush waittill("movedone");
		user unlink();
		wait 0.05;		
		originBrush delete();
	}
}

//-----------------------------------
//Info help -------------------------
//-----------------------------------

/*
* Info sign at the beginning of the map
*/
mapInfo(){
		infoTrigger = getent("infoTrigger","targetname");
		while(1){

			infoTrigger waittill("trigger", user);
			thread infoText(user);
								
		}
}

infoText(user){
	user iPrintLnBold("This map was made by ^2V^7iezeOudeMan.");
	wait(3);
	user iPrintLnBold(" ");
	user iPrintLnBold("This is the smaller version of V_Forgottentomb.");
	wait(3);
	user iPrintLnBold(" ");
	user iPrintLnBold("Cycle trough radio channels to change the music or to turn it off.");
	wait(3);
	user iPrintLnBold(" ");
	user iPrintLnBold("I hope you enjoy it!");	
}

/*
* Links a number of triggers to entities is they are named correctly, names must end with a number counting up from 1
* param entityName: name of the entities ex: test -> it becomes: test1, test2...
* param triggerName: name of the triggers ex: test -> it becomes: test1, test2...
* param numberOfTriggers: the number of triggers and entities that will be linked
*/
linkTrigger(entityName, triggerName, numberOfTriggers){
	for(i = 1; i <= numberOfTriggers; i++){
		trigger[i] = getent(triggerName +  i, "targetname");
		entity[i] = getent(entityName + i, "targetname");
	}
	wait(0.05);
	for(i = 1; i <= numberOfTriggers; i++){
		trigger[i] enableLinkTo();
		trigger[i] linkTo(entity[i]);
	}	
}

//-----------------------------------
//Radio -----------------------------
//-----------------------------------

/*
* Playing music from the radio
*/
playRadio(){
	radio = getent("radio", "targetname");	
	
	while(1){
		radio thread radioTrigger("radioTrigger1");
		radio thread radioTrigger("radioTrigger2");
		radio waittill("channelChanged", user);		
		level.loopRadio = false;
		
		if(level.currentRadioChannel < level.radioChannels){
			level.currentRadioChannel++;
		} 
		else{
			level.currentRadioChannel = 0;
		}
		//changed "radio playsound" to "user playlocalsound"
		switch(level.currentRadioChannel){
			case 0:
				user iPrintLn("Radio off");
				user playlocalsound("SilentForgottentomb");
				wait(1.1);
				break;
			case 1:		
				user playlocalsound("RadioStatic");
				wait(1.1);
				user iPrintLn("^2N^7ujabes - Aruarian dance");
				user playlocalsound("Nujabes");
				level.loopRadio = true;
				thread loopSound("Nujabes", 251, user, "radio", 1, true);
				break;
			case 2:
				user playlocalsound("RadioStatic");
				wait(1.1);
				user iPrintLn("^2C^7ovet - Falkor");
				user playlocalsound("Covet");
				level.loopRadio = true;
				thread loopSound("Covet", 467, user, "radio", 1, true);
				break;
			case 3:
				user playlocalsound("RadioStatic");
				wait(1.1);
				user iPrintLn("^2R^7adiohead - Weird fished/ Arpeggi");
				user playlocalsound("Radiohead");
				level.loopRadio = true;
				thread loopSound("Radiohead", 319, user, "radio", 1, true);
				break;
			case 4:
				user playlocalsound("RadioStatic");
				wait(1.1);
				user iPrintLn("^2H^7ighly Suspect - Serotonia");
				user playlocalsound("Serotonia");
				level.loopRadio = true;
				thread loopSound("Serotonia", 353, user, "radio", 1, true);	
				break;
			default:				
				user playlocalsound("SilentForgottentomb");
				break;
		}
	}
}

/*
* Enable support to trigger the radio from multiple triggers - the radio entity must call this
*/
radioTrigger(radioTriggerName){
	radioTrigger = getent(radioTriggerName, "targetname");
	while(1){
		radioTrigger waittill("trigger", user);
		self notify("channelChanged", user);
	}
}

/*
* sound that arent played from "ambientplay" cant be set "looped" in the .csv file? wtf
* My own looping function for various entities
* param soundName: the sound that will be played
* param soundTime: the sound will start playing again after waitTime has occured soundTime times. ex: soundTime = 10 and waitTime = 0.5 => the loop will continue for 10 iterations with 0.5s in each loop, so the sound will play again in 5 seconds
* param loopingVariable: for indicating which variable should be chosen to determine if its looping
* param entity: the entity that will be playing this sound, also specifies the continuelooping variable later on
* param waitTime: the to wait in each 'while' loop. If u want to stop the loop make sure that the time continueLooping is set to false >= waitTime
* param isLocalSound: true for sounds that are played locally from a player, like this only thep layer will hear the sound
*/
loopSound(soundName, soundTime, entity, loopingVariable, waitTime, isLocalSound){	
	i = 0;
	continueLooping = true;
	
	while(continueLooping){	
		//Check wheter the looping must stop or not by linking global variables
		//ContinueLooping cant be a local parameter for this to work -> use switch for global variable
		switch(loopingVariable){
			case "radio": continueLooping = level.loopRadio;
					break;
			case "clubMusicPlayer": continueLooping =  true;
					break;
			default:
					continueLooping = true;
					break;
		}	
		wait(waitTime);
		if(i >= soundTime){
			if(!isLocalSound){entity playsound(soundName);} 
			else{entity playlocalsound(soundName);}
			i = 0;
		}
		else{
			i++;
		}	
	}
}

//-----------------------------------
//Doors -----------------------------
//-----------------------------------

/*
* Moves all doors in a basic standard way, also moves the trigger with it
*/
moveDoor(doorName, triggerName, isOpen, degrees, time, accelleration, decelleration){
	door = getent(doorName, "targetname");
	doorTrigger = getent(triggerName, "targetname");
	wait(0.05); // Very important, this is needed or else the link wont happen
	doorTrigger enableLinkTo();
	doorTrigger linkTo(door);
	while(1)
	{
		doorTrigger waittill ("trigger");
		if(isOpen){	
			door rotateyaw(degrees, time, accelleration, decelleration);
			door waittill("rotatedone");
			isOpen = !isOpen;
		} 
		else{
			door rotateyaw( 0 - degrees, time, accelleration, decelleration); // -degrees doesnt work -> 0 - degrees
			door waittill("rotatedone");
			isOpen = !isOpen;
		}
	}
}

/*
* The basement door is different from a regular one, it is initially locked
*/
moveBasementDoor(){
	door = getent("basementDoor", "targetname");
	doorTrigger = getent("basementDoorTrigger", "targetname");
	wait(0.05);
	doorTrigger enableLinkTo();
	doorTrigger linkTo(door);
	isOpen = false;
	while(1)
	{
		doorTrigger waittill ("trigger", user);		
		if(level.isKeyTaken){			
			if(isOpen){	
				door rotateyaw(-85, 1, 0.1, 0.1);
				door waittill("rotatedone");
				isOpen = !isOpen;
			} 
			else{
				door rotateyaw(85, 1, 0.1, 0.1);
				door waittill("rotatedone");
				isOpen = !isOpen;			
			}		
		}
		else{
			user iPrintLn("The door is locked.");
		}
	}
}

//-----------------------------------
//Hidden room -----------------------
//-----------------------------------

/*
* Find and open the secret spot to the key
*/
findKey(){
	findKey = getent("findKey","targetname");
	findKeyTrigger = getent("findKeyTrigger","targetname");
	findKeyTrigger waittill ("trigger");
	findKeyTrigger delete();
	findKey rotateyaw (-120, 1.5, 0.1, 0.2);
	findKey waittill("rotatedone");
	thread takeKey(); //only allow takeKey() thread to run after findkey() finished
}

/*
* Take the key for the basement door
*/
takeKey(){
	key = getent("key","targetname");
	keyTrigger = getent("keyTrigger","targetname");
	findKey = getent("findKey","targetname");
	keyTrigger waittill ("trigger", user);
	user iPrintLn("You took the key.");
	level.isKeyTaken = true;
	key delete();
	keyTrigger delete();
	findKey rotateyaw (120, 1.5, 0.1, 0.2);
}

/*
* Hint for the secret wall -> disabled
*/
/*
breakableWallInvestigate(){
	breakableWallInvestigateTrigger = getent("breakableWallInvestigateTrigger","targetname");
	while(1){
		breakableWallInvestigateTrigger waittill("trigger", user);
		user iprintln("This part of the wall looks weak");
	}
}
*/

/*
* Break the hidden wall and enable the lockpad
*/
breakWall(){
	breakableWall = getent("breakableWall","targetname");
	breakableWallTrigger = getent("breakableWallTrigger","targetname");
	breakableWallInvestigateTrigger = getent("breakableWallInvestigateTrigger","targetname");
	breakableWallTrigger waittill("trigger");
	
	//lockpad enables
	thread lockX("0");
	thread lockX("1");
	thread lockX("2");
	thread lockX("3");
	thread lockX("4");
	thread lockX("5");
	thread lockX("6");
	thread lockX("7");
	thread lockX("8");
	thread lockX("9");
	wait(0.05);
	
	breakableWall delete();
	breakableWallTrigger delete();
	breakableWallInvestigateTrigger delete();
}

/*
* Lock that opens the big door, the lock disables when the door opens
* param number: the numbers on the lock from 0-9
*/
lockX(number){
	entityName = "lock" + number;
	lock = getent(entityName, "targetname");
	while(!level.isBigDoorUnlocked){
		lock waittill("trigger", user);
			
		if(!level.isBigDoorUnlocked){
			if(level.inputCodeLength >= 4){
				level.inputCode = "";
				level.inputCodeLength = 0;			
			}		
			level.inputCode = level.inputCode + number;
			level.inputCodeLength++;			
			user iPrintLn("Code: " + level.inputCode);
			
			if(level.inputCode == level.lockCode){
				bigDoor = getent("bigDoor", "targetname");
				bigDoorHandle = getent("bigDoorHandle", "targetname");
				user iPrintLn("The keypad switches off and the door opens");
				bigDoor playsound("BigDoorOpen");
				level.isBigDoorUnlocked = true;
				wait(1.5);
				bigDoor playsound("BigDoorWheel");
				bigDoorHandle rotatepitch(360, 3, 0.1, 0.2);
				bigDoorHandle waittill("rotatedone");
				bigDoor playsound("SilentForgottentomb");
				wait(0.8);
				bigDoor playsound("BigDoorWheel2");
				bigDoorHandle movey(-5, 1.5, 0.1, 0.1);
				bigDoorHandle waittill("movedone");
				bigDoor playsound("SilentForgottentomb");
				wait(0.1);
				bigDoor playsound("BigDoorSlide");
				bigDoor movey(-42, 3, 1, 1);
				bigDoorHandle movey(-42, 3, 1, 1);
				bigDoorHandle waittill("movedone");
				bigDoor movex(-104, 3.15, 1, 2);
				bigDoorHandle movex(-104, 3.15, 1, 2);
				bigDoorHandle waittill("movedone");
				bigDoor playsound("BigDoorEnd");
			}
		}
	}
}

/*
* Moves the elevator from a trigger
* param triggerName: specifies which switch triggers the elevator
*/
moveElevator(triggerName){
	elevator = getent("elevator", "targetname");
	elevatorTrigger = getent(triggerName, "targetname");
	
	while(1){
		elevatorTrigger waittill("trigger", user);
		if(level.elevatorStatus == 2){
			user iPrintLn("The elevator is already moving");
		}
		else if(level.elevatorStatus == 1){
			level.elevatorStatus = 2;			
			user iPrintLn("Elevator moving down");
			elevator movez(-1108, 10, 0.5, 0.5);
			elevator playsound("Elevator");
			elevator waittill("movedone");
			level.elevatorStatus = 0;	
		} 
		else{
			level.elevatorStatus = 2;			
			user iPrintLn("Elevator moving up");
			elevator movez(1108, 10, 0.5, 0.5);
			elevator playsound("Elevator");
			elevator waittill("movedone");
			level.elevatorStatus = 1;	
		}
			
	}
}

//-----------------------------------
//Shooting Range --------------------
//-----------------------------------

/*
* Moving the targets at the shooting range
* param shootingTargetNumber: support for multiple shooting targets if the naming convention is right
* param distance: the sideways distance the target will move
* param time: the time in which it will move
* param accelleration: the accelleration of the movement
* param decelleration: the decelleration of the movement
* param standStillTime: time in between moving sideways
*/
shootingTarget(shootingTargetNumber, distance, time, accelleration, decelleration, standStillTime){
	target = getent("shootingTarget" + shootingTargetNumber, "targetname");
	targetH = getent("shootingTarget" + shootingTargetNumber + "Head", "targetname");
	targetLA = getent("shootingTarget" + shootingTargetNumber + "LeftArm", "targetname");
	targetRA= getent("shootingTarget" + shootingTargetNumber + "RightArm", "targetname");
	targetLL = getent("shootingTarget" + shootingTargetNumber + "LeftLeg", "targetname");
	targetRL = getent("shootingTarget" + shootingTargetNumber + "RightLeg", "targetname");
	targetB = getent("shootingTarget" + shootingTargetNumber + "Body", "targetname");
	wait 0.05;
	
	targetH enableLinkTo();
	targetLA enableLinkTo();
	targetRA enableLinkTo();
	targetLL enableLinkTo();
	targetRL enableLinkTo();
	targetB enableLinkTo();	
	targetH linkTo(target);
	targetLA linkTo(target);
	targetRA linkTo(target);
	targetLL linkTo(target);
	targetRL linkTo(target);
	targetB linkTo(target);
	
	thread targetHit(targetH, "Head", shootingTargetNumber);
	thread targetHit(targetLA, "Left arm", shootingTargetNumber);
	thread targetHit(targetRA, "Right arm", shootingTargetNumber);
	thread targetHit(targetLL, "Left leg", shootingTargetNumber);
	thread targetHit(targetRL, "Right leg", shootingTargetNumber);
	thread targetHit(targetB, "Body", shootingTargetNumber);
	
	while(1){
		target movey(distance, time * level.shootingTargetSpeed, accelleration, decelleration);
		target waittill("movedone");
		wait(standStillTime * level.shootingTargetSpeed);
		target movey(0 - distance, time * level.shootingTargetSpeed, accelleration, decelleration);
		target waittill("movedone");
		wait(standStillTime * level.shootingTargetSpeed);	
	}
}

/*
* Hit detection for the different bodyparts of a shooting target
*/
targetHit(targetTriggerName, textWhenShot, shootingTargetNumber){
	while(1){
		targetTriggerName waittill("trigger", user);
		user iPrintLn("^" + shootingTargetNumber + "" + textWhenShot);
	}
}

/*
* Alters the speed of the moving targets
*/
shootingTargetSpeed(){
	shootingTargetSpeedTrigger = getent("shootingTargetSpeedTrigger","targetname");
	while(1){
		shootingTargetSpeedTrigger waittill("trigger", user);
		if(level.shootingTargetSpeed < 5){
			level.shootingTargetSpeed++;			
		}
		else{
			level.shootingTargetSpeed = 1;
		}
		user iprintln("Speed set to " + level.shootingTargetSpeed);
	}
}

/*
* Hit detection for the grenadeboxes
*/
grenadeBox(grenadeBoxName){
	grenadeBox = getent(grenadeBoxName,"targetname");
	while(1){
		grenadeBox waittill ("trigger", user);
		user iprintln("^6Grenade hit");
	}
}

/*
* Shooting the fast projectile at the shooting range
*/
shootingProjectile(){
	shootingProjectile = getent("shootingProjectile","targetname");
	shootingProjectileTrigger = getent("shootingProjectileTrigger","targetname");
	launchShootingProjectileTrigger = getent("launchShootingProjectileTrigger","targetname");
	wait(0.05);
	shootingProjectileTrigger enableLinkTo();
	shootingProjectileTrigger linkTo(shootingProjectile);
	while(1){
		launchShootingProjectileTrigger waittill("trigger", user);
		thread shootingProjectileTrigger(shootingProjectileTrigger);
		user iprintln("Get ready to shoot the projectile");
		wait(1);
		wait(randomIntRange(1, 3));
		shootingProjectile playsound("BigDoorOpen");
		shootingProjectile movex(1500, 1 * randomIntRange(1, 4), 0, 0);
		shootingProjectile waittill("movedone");
		shootingProjectile movex(-1500, 0.1, 0, 0);
		shootingProjectile waittill("movedone");		
	}
}

/*
* Hitdetection for the projectile at the target range
*/
shootingProjectileTrigger(shootingProjectileTrigger){
	shootingProjectileTrigger waittill("trigger", user);
	user iprintln("You hit the projectile first!");
}

//-----------------------------------
//Super exclusive club --------------
//-----------------------------------

/*
* Plays music when entering the club room
*/
playClubMusic(){
	clubMusicPlayerTrigger = getent("clubMusicPlayerTrigger","targetname");
	clubMusicPlayer = getent("clubMusicPlayer","targetname");
	while(1){
		clubMusicPlayerTrigger waittill("trigger");
		clubMusicPlayer playsound("DarudeSandstorm");
		wait(5);
	}		
}

/*
* Get drunk at the bar each player can be in different 'drunk' stages.
*/
getDrunk(){
	drinkTrigger = getent("drinkTrigger","targetname");
	names = [];
	stages = [];
	stage = 0;
	names[names.size] = "test123";
	stages[stages.size] = 1;
	//iprintln(names[names.size - 1] + " ADDED, STAGE " + stages[stages.size - 1]);
	
	while(1){
		drinkTrigger waittill ("trigger", user);	
		random = randomIntRange(1, 15);
		randomCough = randomIntRange(1, 3);
	
		for(i = 0; i < names.size; i++){
			if(names[i] == user.name){
				if(stages[i] >= 11){ stages[i] = 1; stage = 1;}
				else{stage = stages[i]; stage++; stages[i] = stage;}
				//iprintln(names[i] + " EDITED, STAGE " + stages[i]);
				break;
			}
			else if(i == names.size - 1){
				names[names.size] = user.name;
				stages[stages.size] = 0;
				//iprintln(names[names.size - 1] + " ADDED, STAGE " + stages[stages.size - 1]);
			}
		}
	
		user iprintln("You drink a beer");
		wait(2);
		switch(stage){
			case 1:
				user iprintln("It tastes good, maybe one more?");
				break;
			case 3:
				user iprintln("You're getting a bit drunk");
				thread colorfade("black", 0, 0, 0, 0, 640, 480, 0, 0.2, 0, 1, 1, 0, user);
				wait(2);
				break;
			case 4:
				user iprintln("Its getting worse");
				thread colorfade("black", 0, 0, 0, 0, 640, 480, 0, 0.3, 0, 3, 0.7, 0, user);
				wait(3.7);
				break;
			case 5:
				user iprintln("The effects are getting bigger");
				thread colorfade("black", 0, 0, 0, 0, 640, 480, 0, 0.4, 0, 4, 0.7, 0, user);
				wait(4.7);
				break;
			case 6:
				user iprintln("You feel pretty drunk");
				thread colorfade("black", 0, 0, 0, 0, 640, 480, 0, 0.45, 0.2, 2, 0.7, 0, user);
				wait(2.7);
				thread colorfade("black", 0, 0, 0, 0, 640, 480, 0.2, 0.5, 0, 2, 2, 0, user);
				wait(4);
				break;
			case 7:
				user iprintln("Maybe you should stop drinking");
				thread colorfade("black", 0, 0, 0, 0, 640, 480, 0, 0.6, 0.3, 0.5, 2, 0, user);
				wait(1);
				thread playScream("cough", user, randomCough);
				wait(1.5);
				thread colorfade("black", 0, 0, 0, 0, 640, 480, 0.3, 0.6, 0, 2, 2, 0, user);
				wait(4);
				break;
			case 8:
				user iprintln("You can't walk straight anymore");
				thread playScream("cough", user, randomCough);
				RadiusDamage( user.origin, 1, 1, 1);
				thread colorfade("black", 0, 0, 0, 0, 640, 480, 0, 0.9, 0, 2, 6, 2, user);
				wait(3);
				randomCough = randomIntRange(1, 3);
				thread playScream("cough", user, randomCough);
				wait(7);
				break;
			case 9:
				user iprintln("WHAT ARE THESE THINGS");	
				thread colorfade("black", 0, 0, 0, 0, 640, 480, 0, 0.9, 0, 0.5, 0.5, 11, user);
				thread playScream("scream", user, random);
				RadiusDamage( user.origin, 1, 1, 1);
				for(i = 1; i < 70; i++){
					wait(0.1);
					xStart = randomIntRange(0, 640);
					yStart = randomIntRange(0, 480);
					xEnd = randomIntRange(0, 640);
					yEnd = randomIntRange(0, 480);
					width = randomIntRange(30, 150);
					height = randomIntRange(30, 150);
					thread colorfade("white", xStart, yStart, xEnd, yEnd, width, height, 0, 0.9, 0, 2, 2, 1, user);
					if(i % 30 == 0){
						random = randomIntRange(1, 15);
						thread playScream("scream", user, random);
						RadiusDamage( user.origin, 1, 1, 1);
					}
				}
				wait(2);
				break;
			case 10:
				user iprintln("EVERYTHING WENT DARK");
				thread colorfade("black", 0, 0, 0, 0, 640, 480, 1, 1, 0, 0.05, 0.05, 15, user);
				wait(1);
				thread playScream("scream", user, random);
				wait(3.5);
				random = randomIntRange(1, 15);
				thread playScream("scream", user, random);
				wait(3.5);
				random = randomIntRange(1, 15);
				thread playScream("scream", user, random);
				wait(3.5);
				random = randomIntRange(1, 15);
				thread playScream("scream", user, random);
				wait(4.5);
				user iprintlnBold("THATS IT! NO MORE DRINKS FOR ME!");
				break;
			case 11:
				thread colorfade("black", 0, 0, 0, 0, 640, 480, 1, 1, 0, 0.05, 0.05, 2, user);
				RadiusDamage( user.origin, 1, 1, 1);
				thread playScream("scream", user, random);
				wait(2.1);
				RadiusDamage( user.origin, 1, 1, 1);
				user suicide();
				break;
			default:
				break;
		}
	}
}

/*
* A shader will show up on the players' hud. it will fade in and back out and there is some movement when tere are
* different starting and ending positions.
* param shader:  The image that will be shown
* param startX: The leftmost starting position of the shader
* param startY: The uppermost starting position of the shader
* param endX: The leftmost starting position of the shader
* param endY: The uppermost starting position of the shader
* param width: The width of the shader, 640 is whole screen length
* param height: The heighth of the shader, 480 is whole screen heighth
* param startAlpha: The alpha of the shader when it first shows
* param peakAlpha: The alpha the shader will fade to
* param endAlpha: The alpha the shader will be at the end
* param transitionTime1: Time to go from startAlpha to peakAlpha, cant be 0
* param transitionTime2: Time to go from peakAlpha to endAlpha, cant be 0
* param stayAtPeakAlphaTime: Time that the peakAlpha will be shown
* param user: The player that has this effect
*/
colorfade(shader, startX, startY, endX, endY,  width, height, startAlpha, peakAlpha, endAlpha, transitionTime1, transitionTime2, stayAtPeakAlphaTime,user){
	hud = newClientHudElem(user);
	hud.x = startX;
	hud.y = startY;
	hud.alpha = startAlpha;
	hud setShader(shader, width, height);
	hud MoveOverTime(transitionTime1 + transitionTime2 + stayAtPeakAlphaTime);
	hud.x = endX;
	hud.y = endY;
	hud fadeOverTime(transitionTime1);
	hud.alpha = peakAlpha;
	wait(transitionTime1);
	wait(stayAtPeakAlphaTime);
	hud fadeOverTime(transitionTime2);
	hud.alpha = endAlpha;
	wait (transitionTime2);
	hud destroy();
}

/*
* 
*/
playScream(type, entity, number){
	switch(type){
		case "scream":
			if(number < 10){
			entity playsound("Redsquare_Charge_Walla_0" + number);
			}
			else{
				entity playsound("Redsquare_Charge_Walla_" + number);
			}	
			break;
		case "cough":
			entity playsound("Cough0" + number);
			break;
		default:
			break;
	}
	
}

//-----------------------------------
//Theater room ----------------------
//-----------------------------------

/*
* Moves the brushes auround so they look like different pictures showing up
*/
pictures(){
	pictureBrushes = getent("pictures","targetname");
	pictureBrushesTrigger = getent("picturesTrigger","targetname");
	position = 0;
	numberOfPictures = 3;
	while(1){
		pictureBrushesTrigger waittill("trigger");
		if(position < numberofPictures -1){
			pictureBrushes.origin += (640,0,0);
			position++;
		}
		else{
			pictureBrushes.origin += (-640 * (numberOfPictures - 1) ,0,0);
			position = 0;
		}
	}
}
